您的位置:首页 > 其它

Wooden Sticks(hdu1051,LIS)

2013-08-15 10:19 375 查看
http://acm.hdu.edu.cn/showproblem.php?pid=1051

Wooden Sticks

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 9167 Accepted Submission(s): 3748

Problem Description

There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows:

(a) The setup time for the first wooden stick is 1 minute.

(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l' and weight w' if l<=l' and w<=w'. Otherwise, it will need 1 minute for setup.

You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).

Input

The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1<=n<=5000, that represents the number of wooden sticks in the test case, and the second line contains n 2 positive integers l1, w1, l2, w2, ..., ln, wn, each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces.

Output

The output should contain the minimum setup time in minutes, one per line.

Sample Input

3

5

4 9 5 2 2 1 3 5 1 4

3

2 2 1 1 2 2

3

1 3 2 2 3 1

Sample Output

2

1

3

Source

Asia 2001, Taejon (South Korea)

Statistic | Submit | Discuss | Note

Home | Top Hangzhou Dianzi University Online Judge 3.0

解析:

思路:

按照木棍从小到的顺序排好,其实就是求重量的最长上升子序列个数

78MS 288K 912 B

*/

#include<stdio.h>
#include<string.h>
#include<algorithm>
#include <iostream>
using namespace std;
const int maxn=5010;
int dp[maxn];
struct Node
{
int l;
int w;
}node[maxn];
bool cmp( Node a1, Node a2)
{
return a1.l>a2.l||(a1.l==a2.l&&a1.w>a2.w);
}
int main()
{int T,i,n,ans,j;
scanf("%d",&T);
while(T--)
{
scanf("%d",&n);
if(n==0)
{printf("0\n");
continue;
}
for(i=0;i<n;i++)
scanf("%d%d",&node[i].l,&node[i].w);
sort(node,node+n,cmp);
memset(dp,0,sizeof(dp));
dp[0]=1;
ans=0;
int m;
for(i=1;i<n;i++)
{
m=dp[i];
for(j=0;j<i;j++)
{if(node[i].w>node[j].w)//因为l已经排好序了,只需比较w即可
{
if(dp[j]>m)
m=dp[j];
}
}
dp[i]=m+1;
if(ans<dp[i])
ans=dp[i];
}
// for(i=0;i<n;i++)
//printf("l=%d,w=%d\n",node[i].l,node[i].w);
printf("%d\n",ans);
}
//system("pause");
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: